<?php
/**
 * PagesPerso Plugin: Displays pages perso ...
 * 
 * @license    GPL 2 (http://www.gnu.org/licenses/gpl.html)
 * @author     Eric Seigne <eric.seigne@ryxeo.com>
 */
// must be run within Dokuwiki
if(!defined('DOKU_INC')) die();

if(!defined('DOKU_PLUGIN')) define('DOKU_PLUGIN',DOKU_INC.'lib/plugins/');
require_once(DOKU_PLUGIN.'syntax.php');


include_once("AbE_API.php");
include_once("AbE_Groups.php");

global $USAGERS_GROUP;
global $USAGERS_TITLE;
global $RESPONSABLES_GROUP;
global $RESPONSABLES_TITLE;
global $GROUPS_NAME;
global $GROUP_TITLE;

/**
 * All DokuWiki plugins to extend the parser/rendering mechanism
 * need to inherit from this class
 */
class syntax_plugin_pagesperso extends DokuWiki_Syntax_Plugin {

  /**
   * return some info
   */
  function getInfo(){
    return array(
		 'author' => 'Eric Seigne',
		 'email'  => 'eric.seigne@ryxeo.com',
		 'date'   => '2008-17-09',
		 'name'   => 'PagesPerso Plugin',
		 'desc'   => 'Displays pages perso',
		 'url'    => 'http://www.abuledu.org',
		 );
  }
  
  /**
   * What kind of syntax are we?
   */
  function getType(){
    return 'substition';
  }
  
  /**
   * What about paragraphs?
   */
  function getPType(){
    return 'block';
  }
  
  /**
   * Where to sort in?
   */ 
  function getSort(){
    return 155;
  }
  
  
  /**
   * Connect pattern to lexer
   */
  function connectTo($mode) {
    $this->Lexer->addSpecialPattern('~~PAGESPERSO:\w+~~',$mode,'plugin_pagesperso');
  }
  
  
  /**
   * Handle the match
   */
  function handle($match, $state, $pos, &$handler){
    $match = substr($match,13,-2); //strip ~~INFO: from start and ~~ from end
    return array(strtolower($match));
  }
  
  /**
   * Create output
   */
  function render($format, &$renderer, $data) {
    if($format == 'xhtml'){
      //handle various info stuff
      switch ($data[0]){
      case 'version':
	$renderer->doc .= getVersion();
	break;
      default:
	$renderer->doc .= "" . $this->_abuledu();
	//                    $renderer->doc .= "no info about ".htmlspecialchars($data[0]);
      }
      return true;
    }
    return false;
  }

  
  // --------------------------------------------------------------------
  // Retourne un code spécial :
  // le nombre de fichiers présents dans le répertoire passé en paramètre
  // suivi d'un deux-points et de l'image à afficher à côté de l'entrée
  function fichiers_webs($rep){
    $nb = 0;
    $image = "";

    if(is_dir($rep))
	{
	$nombre = count(scandir($rep));

	// on enlève . et ..
	$nb = $nombre - 2;

	//le résultat est le nombre de fichier pas le nombre de fichiers + nombre de répertoires
	}



    // La date
    if(file_exists($rep))
      if ($timestamp = filemtime($rep)) {
	$actual = time();
	$levelA = 60*60*24; // one day
	$levelB = $levelA*7;// one week
	if($timestamp > ($actual-$levelA))
	  $image="today.png";
	else
	  if($timestamp > ($actual-$levelB))
	    $image="week.png";
	  else
	    $image="old.png";
      }
    return "$nb:$image";
  }


  function _abuledu(){
    global $USAGERS_GROUP;
    global $USAGERS_TITLE;
    global $RESPONSABLES_GROUP;
    global $RESPONSABLES_TITLE;
    global $GROUPS_NAME;
    global $GROUP_TITLE;
    $retour .= "<h1><a name=\"Pages perso\">" . _("Pages personnelles") ."</a></h1>";

    // $retour .= '<ul>';
    $groupes = new AbE_Groups();
    
    $retour .= "  <table width=\"100%\">
  <tr>
    <th>$USAGERS_TITLE</th>";
	/* colonne pour responsables
 <th>$RESPONSABLES_TITLE</th> */
    $retour .= "<th>$GROUP_TITLE</th>
  </tr>
  <tr>
    <td style=\"vertical-align: top; width: 33%; text-align: center\">
";

      $liste_des_u = $groupes->GetMembers(strtolower($USAGERS_GROUP));
      if(($liste_des_u != -1) && (count($liste_des_u)>0)){
	sort($liste_des_u);
	for($i = 0; $i < count($liste_des_u); $i++)
	  {
	    $fiw = $this->fichiers_webs("/home/" . $USAGERS_GROUP . "/$liste_des_u[$i]/public_html");
	    $res = explode(":",$fiw);
	    $img = "";
	    if($res[1])
	      $img = "<img src=\"/images/$res[1]\" align=\"absmiddle\">";
	    if($res[0]>0)
	      $retour .= "   $img <a href=\"/~$liste_des_u[$i]/\">$liste_des_u[$i]</a> ($res[0])<br>\n";
	  }
      }
      
      $retour .= "
    </td>
    <td style=\"vertical-align: top; width: 33%; text-align: center\">
";

      /* Suppression si plus d'enseignants - Voir s'il faut réintégrer pour responsables ?
	$liste_des_r = $groupes->GetMembers(strtolower($RESPONSABLES_GROUP));
      if(($liste_des_r != -1) && (count($liste_des_r)>0)){
	sort($liste_des_r);
	for($i = 0; $i < count($liste_des_r); $i++)
	  { 
	    $fiw = $this->fichiers_webs("/home/" . $RESPONSABLES_GROUP . "/$liste_des_r[$i]/public_html");
	    $res = explode(":",$fiw);
	    $img = "";
	    if($res[1])
	      $img = "<img src=\"/images/$res[1]\">";
	    if($res[0]>0) {
	      exec("grep '^" . $liste_des_r[$i] . ":' /etc/passwd | cut -d\":\" -f5 | sed -e \"s/" . $RESPONSABLES_TITLE . " //\" -e \"s/ \/ / /\"", $out);
	      $retour .= "   $img <a href=\"/~$liste_des_r[$i]/\">" . (empty($out[0])?$liste_des_r[$i]:$out[0]) . "</a><br />\n";
	      unset($out);
	    }
	  }
      }
	*/

      /* $retour .= "
    </td>
    <td style=\"vertical-align: top; width: 33%; text-align: center\">
";

	*/

      $liste_des_groupes = $groupes->GetListOfAvailableGroups();

      if(($liste_des_groupes != -1) && (count($liste_des_groupes)>0)){
	sort($liste_des_groupes);
	for($i = 0; $i < count($liste_des_groupes); $i++)
	  {
	    $fiw = $this->fichiers_webs("/home/" . strtolower($GROUPS_NAME) . "/$liste_des_groupes[$i]/public_html");
	    $res = explode(":",$fiw);
	    $img = "";
	    if($res[1])
	      $img = "<img src=\"/images/$res[1]\">";
	    if($res[0]>0)
	      $retour .= "   $img <a href=\"/groupeswebs/$liste_des_groupes[$i]/\">$liste_des_groupes[$i]</a> ($res[0])<br>\n";
	  }
      }
      $retour .= "
    </td>
  </tr>
  </table>


<div>
  <h4>Vous n'êtes pas dans la liste&nbsp;?</h4>
  <p>Si vous n'apparaissez pas dans la liste ci-dessus, c'est parce que vous n'avez pas encore enregistré de fichier (page Web ou autre) dans votre répertoire <code>public_html/</code> ou celui de votre groupe&nbsp;!</p>

</div>


";
      
      return $retour;
    }
  

}

